﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace XamGridPaging
{
    public class Customer : INotifyPropertyChanged
    {
        private int customerID;
        private Name customerName;

        public int CustomerID
        {
            get
            {
                return customerID;
            }
            set
            {
                customerID = value;
                NotifyPropertyChanged("CustomerID");
            }
        }

        public Name CustomerName
        {
            get
            {
                return customerName;
            }
            set
            {
                customerName = value;
                NotifyPropertyChanged("CustomerName");
            }
        }

        public Customer(int customerID, Name customerName)
        {
            CustomerID = customerID;
            CustomerName = customerName;
        }

        public Customer()
        {
        }


        #region INotifyPropertyChanged Members
        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        #endregion
    }


    #region Name class
    public class Name
    {
        public Name()
        {
        }

        private string firstName;
        private string lastName;

        public string FirstName
        {
            get
            {
                return firstName;
            }
            set
            {
                firstName = value;
            }
        }

        public string LastName
        {
            get
            {
                return lastName;
            }
            set
            {
                lastName = value;
            }
        }

        public Name(string firstName, string lastName)
        {
            this.FirstName = firstName;
            this.LastName = lastName;
        }

        public override string ToString()
        {
            return string.Format("{0} {1}", this.FirstName, this.LastName);
        }
    } 
    #endregion
}
